﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using TradingAPI.MT4Server;
using Xamarin2.Models;

namespace Xamarin2.Services
{
	public class MockDataStore : IDataStore<Item>
	{
		List<Item> items;

		public MockDataStore()
		{
			QuoteClient qc = new QuoteClient(67611, "wx1yhpn", "demo.fxgerchik.com", 443);
			Console.WriteLine("Connecting...");
			qc.Connect();
			items = new List<Item>();
			var mockItems = new List<Item>
				{
					 new Item { Id = Guid.NewGuid().ToString(), Text = "Account balance: " + qc.AccountBalance, Description= "AccountName: " + qc.AccountName},
				};

			foreach (var item in mockItems)
			{
				items.Add(item);
			}
		}

		public async Task<bool> AddItemAsync(Item item)
		{
			items.Add(item);

			return await Task.FromResult(true);
		}

		public async Task<bool> UpdateItemAsync(Item item)
		{
			var oldItem = items.Where((Item arg) => arg.Id == item.Id).FirstOrDefault();
			items.Remove(oldItem);
			items.Add(item);

			return await Task.FromResult(true);
		}

		public async Task<bool> DeleteItemAsync(string id)
		{
			var oldItem = items.Where((Item arg) => arg.Id == id).FirstOrDefault();
			items.Remove(oldItem);

			return await Task.FromResult(true);
		}

		public async Task<Item> GetItemAsync(string id)
		{
			return await Task.FromResult(items.FirstOrDefault(s => s.Id == id));
		}

		public async Task<IEnumerable<Item>> GetItemsAsync(bool forceRefresh = false)
		{
			return await Task.FromResult(items);
		}
	}
}